[BACK]Return to update_openbsd CVS log [TXT][DIR] Up to [local] / openbsd / update_openbsd

Annotation of openbsd/update_openbsd/update_openbsd, Revision 1.63

1.1       andrew      1: #!/bin/sh
1.63    ! andrew      2: # $AFresh1: update_openbsd,v 1.62 2014/01/23 02:40:07 andrew Exp $
1.41      andrew      3: #
                      4: # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>
                      5: #
                      6: # Permission to use, copy, modify, and distribute this software for any
                      7: # purpose with or without fee is hereby granted, provided that the above
                      8: # copyright notice and this permission notice appear in all copies.
                      9: #
                     10: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     11: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     12: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     13: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     14: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     15: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     16: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     17: #
1.7       andrew     18:
1.2       andrew     19: installed_sets() {
1.5       andrew     20:     local misc=/usr/share/doc/README
1.63    ! andrew     21:     local man=/usr/share/man/man1/intro.1
1.5       andrew     22:     local comp=/usr/bin/cc
                     23:     local game=/usr/games/
                     24:     local xbase=/usr/X11R6/
                     25:     local xetc=/etc/X11/xinit/xinitrc
                     26:     local xfont=/usr/X11R6/lib/X11/fonts
                     27:     local xserv=/usr/X11R6/bin/X
                     28:     local xshare=/usr/X11R6/bin/startx
                     29:
                     30:     local _c _d _e
                     31:     echo -n base
                     32:     echo -n ' etc'
1.3       andrew     33:     for _d in misc man comp game xbase xetc xfont xserv xshare; do
                     34:         eval _e=\$${_d}
                     35:         _c=`ls $_e 2> /dev/null | wc -l`
                     36:         #echo $_c $_d $_e
                     37:         if [ $_c -ne 0 ]; then
1.5       andrew     38:             echo -n " $_d"
1.2       andrew     39:         fi
                     40:     done
1.19      andrew     41:
1.34      andrew     42:     sendmail -d0.1 --badoption </dev/null 2>/dev/null | grep -q SASL
1.19      andrew     43:     if [ $? == 0 ]; then
                     44:         echo -n ' sendmail-smtp_auth'
                     45:     fi
1.2       andrew     46: }
1.7       andrew     47:
1.39      andrew     48: kernel_file_version() {
                     49:     echo exit | config -e $1 | grep -A1 ^OpenBSD
                     50:     #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'
                     51: }
                     52:
1.16      andrew     53: version_in() {
1.10      andrew     54:         local _proto=${FTP%%://*}
1.16      andrew     55:         local _file
1.10      andrew     56:
                     57:         if [ X"ftp" == X"${_proto}" ]; then
1.16      andrew     58:             local _list=`echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/`
                     59:             _file=`echo ${_list} | awk '/base[0-9][0-9].tgz/ { print $9 }'`
1.15      andrew     60:
1.10      andrew     61:         elif [ X"http" == X"${_proto}" ]; then
1.16      andrew     62:             local _list=`${FTP_CMD} -V -o - ${FTP}/`
                     63:             _file=`echo ${_list} | awk '/[^x]base[0-9][0-9]*\.tgz/ {
1.15      andrew     64:                     sub("^.*base","base");
                     65:                     sub("\.tgz.*",".tgz");
                     66:                     print $0;
1.16      andrew     67:                 }'`
1.15      andrew     68:
                     69:         elif [ X"scp" == X"${_proto}" ]; then
                     70:             echo SCP is not yet supported >&2
                     71:             return 2
                     72:
1.10      andrew     73:         else
                     74:             echo Unsupported FTP ${FTP} >&2
1.12      andrew     75:             return 2
1.15      andrew     76:
1.10      andrew     77:         fi
1.16      andrew     78:
                     79:         local _v=${_file##*base}
                     80:         _v=${_v%.tgz*}
                     81:         echo $_v
1.10      andrew     82: }
1.2       andrew     83:
                     84: set_version() {
                     85:     CUR_VER=`uname -r`
1.3       andrew     86:     NEW_VER=`dc -e "$CUR_VER 0.1 + p"`
1.5       andrew     87:     FILE_VER=""
                     88:     FTP=""
1.2       andrew     89:
1.5       andrew     90:     local _cv=`echo $CUR_VER | sed -e 's/\.//'`
                     91:     local _nv=`echo $NEW_VER | sed -e 's/\.//'`
1.9       andrew     92:     local _v
1.5       andrew     93:
1.10      andrew     94:     if [ X"No" != X"$FORCE_DIR" -a -d $FORCE_DIR ]; then
1.5       andrew     95:         _dir=$FORCE_DIR
                     96:         if [ -e ${_dir}/base${_nv}.tgz ]; then
                     97:             _v=$_nv
                     98:         elif [ -e ${_dir}/base${_cv}.tgz ]; then
                     99:             NEW_VER=$CUR_VER
                    100:             _v=$_cv
                    101:         fi
1.2       andrew    102:
1.5       andrew    103:     elif [ -d $CUR_VER ]; then
                    104:         _dir=$CUR_VER
1.2       andrew    105:         NEW_VER=$CUR_VER
1.5       andrew    106:         if [ -e ${_dir}/base${_cv}.tgz ]; then
                    107:             _v=$_cv
                    108:         fi
1.2       andrew    109:
1.5       andrew    110:     elif [ -d $NEW_VER ]; then
                    111:         _dir=$NEW_VER
                    112:         if [ -e ${_dir}/base${_nv}.tgz ]; then
                    113:             _v=$_nv
                    114:         fi
1.2       andrew    115:
                    116:     fi
                    117:
1.17      andrew    118:     if [ X"" != X"${MIRROR}" -a X"" == X"${_v}" ]; then
1.10      andrew    119:         if [ X"No" == X"${FORCE_DIR}" ]; then
1.5       andrew    120:             _dir=${NEW_VER}
                    121:         else
                    122:             _dir=${FORCE_DIR}
                    123:         fi
                    124:         FTP=${MIRROR}/${_dir}/`machine`
1.2       andrew    125:
1.16      andrew    126:         _v=`version_in`
1.10      andrew    127:
1.16      andrew    128:         if [ X"" == X"${_v}" ]; then
1.10      andrew    129:             if [ X"No" != X"$FORCE_DIR" ]; then
                    130:                 echo No sets in forced [${FTP}] >&2
1.12      andrew    131:                 return 2
1.10      andrew    132:             fi
                    133:
                    134:             NEW_VER=$CUR_VER
                    135:             _dir=${NEW_VER}
                    136:             FTP=${MIRROR}/${_dir}/`machine`
                    137:
1.16      andrew    138:             _v=`version_in`
1.9       andrew    139:         fi
                    140:
1.10      andrew    141:         if [ X"" == X"${_v}" ]; then
1.16      andrew    142:             echo No sets in [${FTP}] >&2
1.12      andrew    143:             return 2
1.10      andrew    144:         elif [ X"${_cv}" == X"${_v}" ]; then
1.5       andrew    145:             NEW_VER=$CUR_VER
1.9       andrew    146:         elif [ X"${_nv}" == X"${_v}" ]; then
                    147:             NEW_VER=$NEW_VER
1.2       andrew    148:         else
1.10      andrew    149:             echo Invalid version [$_v] >&2
1.12      andrew    150:             return 2
1.2       andrew    151:         fi
                    152:
1.10      andrew    153:         if [ X"No" == X"$FORCE_DIR" ]; then
1.5       andrew    154:             _dir=$NEW_VER
1.2       andrew    155:         fi
                    156:
                    157:     fi
                    158:
1.5       andrew    159:     if [ X"" == X"${_v}" ]; then
                    160:         echo ERROR: Unable to determine file version! >&2
1.12      andrew    161:         return 1
1.2       andrew    162:     fi
                    163:
1.5       andrew    164:     if [ X"" == X"$RELEASEDIR" ]; then
                    165:         RELEASEDIR=`pwd`/$_dir
1.2       andrew    166:     fi
1.9       andrew    167:
1.5       andrew    168:     FILE_VER=$_v
1.17      andrew    169:     if [ X"" != X"${MIRROR}" ]; then
                    170:         FTP=${MIRROR}/${_dir}/`machine`
                    171:     fi
1.39      andrew    172:
                    173:     BOOT_KERNEL=`( \
                    174:         echo bsd; \
                    175:         [ -e /boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \
                    176:             s///; s/^.*://; s/ .*$//' /boot.conf \
                    177:     ) | tail -1`
1.42      andrew    178:     BOOT_KERNEL=`follow_symlink /$BOOT_KERNEL`
1.39      andrew    179:     BOOT_KERNEL="/${BOOT_KERNEL#/}"
                    180:
                    181:     BOOT_KERNEL_VERSION=`kernel_file_version $BOOT_KERNEL`
                    182:
                    183:     BOOTED_KERNEL_VERSION=`sysctl -n kern.version`
                    184:     NEW_KERNEL_VERSION=""
                    185:
                    186:     # We want to default to what we had
                    187:     INSTALL_KERNELS="${BOOT_KERNEL#/}"
1.48      andrew    188:     # if the boot kernel was our specially named bsd.sp, we install from bsd
                    189:     if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then
                    190:         INSTALL_KERNELS="bsd"
                    191:     fi
1.39      andrew    192:     # with a second option of an mp kernel if is is a likely candidate
                    193:     if [ X"$INSTALL_KERNELS" != X"bsd.mp" ]; then
                    194:         local _ncpu=$(sysctl -n hw.ncpufound)
                    195:         [ $_ncpu -gt 1 ] && INSTALL_KERNELS="$INSTALL_KERNELS bsd.mp"
                    196:     fi
                    197:     # or just bsd otherwise
                    198:     if [ X"${INSTALL_KERNELS% *}" != X"bsd" ]; then
                    199:         INSTALL_KERNELS="$INSTALL_KERNELS bsd"
                    200:     fi
                    201:     BOOT_KERNELS=$INSTALL_KERNELS
                    202:     INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"
1.2       andrew    203: }
                    204:
                    205: get_sets() {
1.54      andrew    206:     echo '==> GETTING SETS'
1.2       andrew    207:     if [ X"" == X"$FTP" ]; then
1.5       andrew    208:         echo ERROR: No FTP site set! >&2
1.12      andrew    209:         return 1
1.2       andrew    210:     fi
                    211:
1.5       andrew    212:     mkdir -p ${RELEASEDIR}
                    213:     cd $RELEASEDIR
1.2       andrew    214:
1.5       andrew    215:     local _v=$FILE_VER
1.2       andrew    216:
1.39      andrew    217:     for _b in $INSTALL_KERNELS; do
1.45      andrew    218:         if [ ! -e ./${_b} ]; then
1.54      andrew    219:             echo "===> $FTP_CMD ${FTP}/${_b}"
1.3       andrew    220:             $FTP_CMD ${FTP}/${_b}
1.2       andrew    221:         fi
                    222:     done
                    223:
1.5       andrew    224:     for _s in $INSTALLED_SETS; do
1.19      andrew    225:         local _file=${_s}${_v}.tgz
                    226:         if [ ${_s} == sendmail-smtp_auth ]; then
                    227:             _file=${_s}.gz
                    228:         fi
                    229:
                    230:         if [ ! -e ./${_file} ]; then
1.54      andrew    231:             echo "===> $FTP_CMD ${FTP}/${_file}"
1.19      andrew    232:             $FTP_CMD ${FTP}/${_file}
1.5       andrew    233:         fi
1.2       andrew    234:     done
                    235:
1.20      andrew    236:     local _type
1.56      andrew    237:     local _ftp
1.20      andrew    238:     for _type in $CHECKSUM_TYPES; do
1.40      andrew    239:         [ -e $_type ] && break
1.56      andrew    240:         _ftp=`echo "$FTP" | sed -e 's,://[^/]*/,://ftp.openbsd.org/,'`
                    241:         echo "===> $FTP_CMD ${_ftp}/$_type"
                    242:         $FTP_CMD ${_ftp}/$_type
1.20      andrew    243:     done
1.17      andrew    244: }
                    245:
1.23      andrew    246: follow_symlink () {
                    247:     local _file=$1
1.33      andrew    248:     # This could go circular, but I dunno how to fix that.
                    249:     if [ -h $_file ]; then
                    250:         follow_symlink $( file $_file |
                    251:             grep 'symbolic link' |
                    252:             sed -e s/^.*\\\`// -e s/\\\'\$// )
1.23      andrew    253:     else
1.33      andrew    254:         echo $_file
1.23      andrew    255:     fi
                    256: }
                    257:
1.20      andrew    258: check_sum () {
                    259:     local _type=$1
1.54      andrew    260:     echo "==> CHECKING $_type SUMS"
1.17      andrew    261:     cd $RELEASEDIR
                    262:
1.20      andrew    263:     if [ ! -e $_type ]; then
                    264:         echo $_type File does not exist!
1.17      andrew    265:         return 1
                    266:     fi
1.6       andrew    267:
1.57      andrew    268:     local _nv=`echo $NEW_VER | sed -e 's/\.//'`
1.61      andrew    269:     local _signify=`which signify 2>/dev/null`
1.59      andrew    270:     local _keyfile=/etc/signify/${_nv}base.pub
                    271:     local _b _s
1.57      andrew    272:
                    273:     (
1.58      andrew    274:         for _b in $INSTALL_KERNELS; do echo "($_b)"        ; done
                    275:         for _s in $INSTALLED_SETS;  do echo "($_s$_nv.tgz)"; done
1.57      andrew    276:     ) > index
1.59      andrew    277:
                    278:
                    279:     if [ -n "$_signify" -a "$_type" != "${_type%.sig}" ]; then
                    280:         echo "===> Checking signature";
                    281:         if [ ! -e $_keyfile ]; then
                    282:             echo "key [$_keyfile] does not exist, cannot check $_type" >&2
                    283:             return 2
                    284:         fi
                    285:         signify -V -e -p $_keyfile -x $_type -m - | grep -f index | sum -c -
                    286:     else
                    287:        grep -f index $_type | sum -c
                    288:     fi
1.2       andrew    289:
                    290:     if [ $? -ne 0 ]; then
1.20      andrew    291:         echo ERROR: $_type does not match! >&2
1.12      andrew    292:         return 1
1.2       andrew    293:     fi
                    294: }
                    295:
1.17      andrew    296: check_sets() {
1.54      andrew    297:     echo '==> CHECKING SETS'
1.17      andrew    298:     cd $RELEASEDIR
                    299:
1.18      andrew    300:     local _missing_sets
1.17      andrew    301:     local _v=$FILE_VER
                    302:
1.39      andrew    303:     for _n in $INSTALL_KERNELS; do
                    304:         local _o=$_n
                    305:         [ X"bsd" == X"${_o}" -a -e /bsd.sp ] && _o=bsd.sp
                    306:         if [ -e /${_o} -a ! -e ./${_n} ]; then
                    307:             echo ${_o} does not exist
                    308:             _missing_sets=1
1.17      andrew    309:         fi
1.39      andrew    310:
                    311:         if [ X"${BOOT_KERNEL}" == X"/${_o}" -a -e ./${_n} ]; then
                    312:             NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`
1.17      andrew    313:         fi
                    314:     done
                    315:
1.39      andrew    316:     if [ X"$NEW_KERNEL_VERSION" == X"" ]; then
                    317:         echo Missing replacement for boot kernel $BOOT_KERNEL >&2
                    318:         _missing_sets=1
                    319:     fi
                    320:
1.17      andrew    321:     for _s in $INSTALLED_SETS; do
1.19      andrew    322:         local _file=${_s}${_v}.tgz
                    323:         if [ ${_s} == sendmail-smtp_auth ]; then
                    324:             _file=${_s}.gz
                    325:         fi
                    326:         if [ ! -e ./${_file} ]; then
                    327:             echo ${_file} does not exist
1.18      andrew    328:             _missing_sets=1
1.17      andrew    329:         fi
                    330:     done
1.18      andrew    331:
                    332:     if [ X"" == X"${_missing_sets}" ]; then
1.54      andrew    333:         echo '===> All OK'
1.18      andrew    334:     fi
1.17      andrew    335:
1.20      andrew    336:     local _type
                    337:     for _type in $CHECKSUM_TYPES; do
                    338:         if [ -e $_type ]; then
1.59      andrew    339:             check_sum $_type && break
1.62      andrew    340:             [ -z "$IGNORE_CHECKSUM_ERROR" ] && exit 1
1.20      andrew    341:         fi
                    342:     done
1.59      andrew    343:
                    344:     return 0
1.17      andrew    345: }
                    346:
                    347:
1.30      andrew    348: install_kernels() {
1.54      andrew    349:     echo '==> INSTALLING KERNEL'
1.3       andrew    350:     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then
1.2       andrew    351:         echo ${0##*/} must be run as root or SUDO must be set! >&2
                    352:         exit 1
                    353:     fi
                    354:
                    355:     if [ X"" == X"$RELEASEDIR" ]; then
1.5       andrew    356:         echo ERROR: no source for new kernels! >&2
1.2       andrew    357:         exit 1
                    358:     fi
                    359:
1.46      andrew    360:     if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
1.54      andrew    361:         echo "===> Backing up $BOOT_KERNEL to /obsd"
1.46      andrew    362:         $SUDO ln -f $BOOT_KERNEL /obsd
                    363:         if [ $? -ne 0 ]; then
                    364:             echo "Error copying old kernel!" >&2
                    365:             exit 1
                    366:         fi
1.2       andrew    367:     fi
                    368:
1.39      andrew    369:     cd $RELEASEDIR
1.23      andrew    370:
1.39      andrew    371:     for _b in $INSTALL_KERNELS; do
1.3       andrew    372:         $SUDO rm -f /nbsd
1.39      andrew    373:         local _bd=$_b
                    374:         [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"
1.2       andrew    375:
1.39      andrew    376:         local _is_boot=""
                    377:         [ X"$BOOT_KERNEL" == X"/${_bd}" ] && _is_boot="# boot kernel"
                    378:
1.54      andrew    379:         echo "===> Copying $_b to /$_bd $_is_boot"
1.39      andrew    380:         $SUDO cp ${_b} /nbsd && $SUDO mv /nbsd /${_bd}
1.2       andrew    381:         if [ $? -ne 0 ]; then
1.39      andrew    382:             echo ERROR: Could not copy new $_bd kernel! >&2
1.2       andrew    383:             exit 1
                    384:         fi
1.39      andrew    385:     done
                    386:
                    387:     cd $OLDPWD
1.23      andrew    388:
1.39      andrew    389:     if [ ! -h /bsd ]; then
                    390:            cd /
                    391:         for _b in $BOOT_KERNELS; do
                    392:             [ X"$_b" == X"bsd" ] && _b="bsd.sp"
                    393:             if [ -e $_b ]; then
1.54      andrew    394:                 echo "===> symlinking $_b to /bsd"
1.39      andrew    395:                 $SUDO ln -sf $_b bsd
                    396:                 if [ $? -ne 0 ]; then
                    397:                     echo ERROR: Could not symlink new kernel! >&2
                    398:                     exit 1
                    399:                 fi
                    400:                 break
                    401:             fi
                    402:         done
                    403:            cd $OLDPWD
1.2       andrew    404:     fi
                    405: }
                    406:
                    407: install_sets() {
1.54      andrew    408:     echo '==> INSTALLING SETS'
1.3       andrew    409:     if [ X"$USER" != X"root" -a X"$SUDO" == X"" ]; then
1.2       andrew    410:         echo ${0##*/} must be run as root or SUDO must be set! >&2
                    411:         exit 1
                    412:     fi
                    413:
                    414:     if [ X"" == X"$RELEASEDIR" ]; then
1.5       andrew    415:         echo ERROR: no source for sets! >&2
1.2       andrew    416:         exit 1
                    417:     else
                    418:         cd $RELEASEDIR
                    419:     fi
                    420:
1.5       andrew    421:     local _v=$FILE_VER
                    422:
1.21      andrew    423:     local _sets=`ls *${_v}.tgz | grep -v ^base `
                    424:     for _f in ${_sets} base${_v}.tgz; do
1.3       andrew    425:         _path=$DESTDIR
                    426:         if [ X"etc${_v}.tgz"  == X"$_f" \
                    427:             -o X"xetc${_v}.tgz" == X"$_f" ]; then
1.21      andrew    428:             [ X"" != X"$SYSMERGE" ] && continue
1.2       andrew    429:             _path=/var/tmp/temproot
                    430:         fi
                    431:
1.54      andrew    432:         echo "===> Extracting $_f to $_path"
1.3       andrew    433:         $SUDO mkdir -p $_path
                    434:         $SUDO tar -C $_path -xzphf ${RELEASEDIR}/${_f}
1.2       andrew    435:         if [ $? -ne 0 ]; then
1.5       andrew    436:             echo ERROR: Could not extract ${_f}! >&2
1.2       andrew    437:             exit 1
                    438:         fi
                    439:     done
                    440:
1.54      andrew    441:     echo '===> Extracted all sets.'
1.51      andrew    442: }
1.19      andrew    443:
1.51      andrew    444: install_sendmail_smtp_auth() {
1.19      andrew    445:     if [ -e ${RELEASEDIR}/sendmail-smtp_auth.gz ]; then
                    446:         gzcat ${RELEASEDIR}/sendmail-smtp_auth.gz > \
                    447:             ${RELEASEDIR}/sendmail-smtp_auth
                    448:     fi
                    449:     if [ -e ${RELEASEDIR}/sendmail-smtp_auth ]; then
1.21      andrew    450:         if ! pkg_info -qe 'cyrus-sasl-*'; then
                    451:             $SUDO pkg_add -i cyrus-sasl
                    452:         fi
                    453:
                    454:         $SUDO install -o root -g smmsp -m 2555 \
1.19      andrew    455:             ${RELEASEDIR}/sendmail-smtp_auth \
1.21      andrew    456:             /usr/libexec/sendmail/sendmail
1.19      andrew    457:
1.54      andrew    458:         echo '===> Installed sendmail with smtp_auth'
1.19      andrew    459:     fi
1.2       andrew    460: }
                    461:
                    462: update_etc() {
1.54      andrew    463:     echo '==> UPDATING ETC'
1.10      andrew    464:     if [ ! -e $SYSMERGE ]; then
1.47      andrew    465:         echo "ERROR: Can't find sysmerge!" >&2
                    466:         exit 1;
1.10      andrew    467:     fi
                    468:
1.47      andrew    469:     if [ X"" == X"$RELEASEDIR" ]; then
                    470:         echo "ERROR: no source for etc!" >&2
                    471:         exit 1
                    472:     fi
1.2       andrew    473:
1.47      andrew    474:     cd $RELEASEDIR
1.5       andrew    475:
1.47      andrew    476:     local _v=$FILE_VER
                    477:     local _args=""
                    478:     if [ -e etc${_v}.tgz ]; then
1.60      andrew    479:         _args="$_args -s ${RELEASEDIR}/etc${_v}.tgz"
1.47      andrew    480:     fi
                    481:     if [ -e xetc${_v}.tgz ]; then
1.60      andrew    482:         _args="$_args -x ${RELEASEDIR}/xetc${_v}.tgz"
1.47      andrew    483:     fi
                    484:     if [ X"" == X"$_args" ]; then
                    485:         echo ERROR: No upgrade sets found! >&2
1.2       andrew    486:     else
1.54      andrew    487:         echo '==> RUNNING SYSMERGE'
1.47      andrew    488:         $SUDO $SYSMERGE $_args
                    489:     fi
1.2       andrew    490:
1.47      andrew    491:     cd $OLDPWD
1.2       andrew    492: }
1.14      andrew    493:
1.20      andrew    494:
1.14      andrew    495: if [ -e /etc/update_openbsd.conf ]; then
                    496:     . /etc/update_openbsd.conf
                    497: fi
                    498:
                    499: if [ -e ${HOME}/.update_openbsdrc ]; then
                    500:     . ${HOME}/.update_openbsdrc
                    501: fi
                    502:
1.17      andrew    503: #MIRROR=${MIRROR:=ftp://ftp.openbsd.org/pub/OpenBSD}
1.14      andrew    504: FTP_CMD=${FTP_CMD:=ftp -V}
                    505: PKG_PATH=${PKG_PATH:=/usr/ports/packages/`machine`/all/:${MIRROR}/`uname -r`/packages/`machine`/}
                    506:
                    507: DESTDIR=${DESTDIR:=/}
                    508: SYSMERGE=${SYSMERGE:=/usr/sbin/sysmerge}
                    509: FORCE_DIR=${FORCE_DIR:=No}
                    510:
                    511: INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}
1.2       andrew    512:
1.59      andrew    513: CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256.sig SHA256}
1.20      andrew    514:
1.2       andrew    515: set_version
1.12      andrew    516: local _error=$?
1.2       andrew    517:
                    518: echo
                    519: echo "-= update_openbsd - helper script to update OpenBSD =-"
                    520: echo "------------------------------------------------------"
                    521: echo
1.39      andrew    522: echo "           SUDO: $SUDO"
                    523: echo "       SYSMERGE: $SYSMERGE"
                    524: echo "         MIRROR: $MIRROR"
                    525: echo "     RELEASEDIR: $RELEASEDIR"
                    526: echo "        DESTDIR: $DESTDIR"
                    527: echo "    BOOT_KERNEL: $BOOT_KERNEL"
                    528: echo "INSTALL_KERNELS: $INSTALL_KERNELS"
                    529: echo " INSTALLED_SETS: $INSTALLED_SETS"
1.8       andrew    530: echo
1.39      andrew    531: echo "        CUR_VER: $CUR_VER"
                    532: echo "        NEW_VER: $NEW_VER"
                    533: #echo "       FILE_VER: $FILE_VER"
1.2       andrew    534: echo
1.12      andrew    535:
                    536: if [ ${_error} -ne 0 ]; then
                    537:        exit ${_error}
                    538: fi
1.2       andrew    539:
1.17      andrew    540: if [ X"" != X"${FTP}" ]; then
1.20      andrew    541:     get_sets
1.17      andrew    542: fi
                    543:
                    544: check_sets || exit
1.39      andrew    545:
1.54      andrew    546: echo "===> Last booted:\n$BOOTED_KERNEL_VERSION"
1.39      andrew    547: if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
                    548:   -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
                    549:     echo "Next boot (unless replaced):\n$BOOT_KERNEL_VERSION"
                    550: fi
                    551: if [ -n "$NEW_KERNEL_VERSION" ]; then
1.54      andrew    552:     echo "===> New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";
1.39      andrew    553: else
                    554:     echo "\n!!! WARNING: Will not replace boot kernel $BOOT_KERNEL! !!!\n" >&2
                    555:     echo "ctrl+C to cancel, enter to continue anyway" >&2
1.44      andrew    556:     local _temp
                    557:     read _temp
1.53      andrew    558:     NEW_KERNEL_VERSION=$BOOT_KERNEL_VERSION
1.44      andrew    559: fi
                    560:
                    561: if [ -n "$SUDO" -a $CUR_VER != $NEW_VER ]; then
                    562:     echo >&2
                    563:     echo "!!! You are upgrading between OpenBSD versions.     !!!" >&2
                    564:     echo "!!! You should make sure you have a root shell open !!!" >&2
                    565:     echo "!!! It is needed in order to run /sbin/oreboot.     !!!" >&2
                    566:     echo "!!! sudo MAY NOT WORK after sets are extracted.     !!!" >&2
                    567:     echo >&2
                    568:     echo "ctrl+C to cancel, enter to continue" >&2
1.39      andrew    569:     local _temp
                    570:     read _temp
                    571: fi
1.2       andrew    572:
1.43      andrew    573: if [ -n "$SUDO" ]; then
                    574:     echo
                    575:     echo You may be asked for your sudo password multiple times.
                    576:     $SUDO -v -p "sudo Password: "
1.50      andrew    577: fi
                    578:
1.53      andrew    579: if [ X"$NEW_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
1.50      andrew    580:      -a ! -e /sbin/oreboot ]; then
                    581:     $SUDO cp /sbin/reboot /sbin/oreboot
                    582:     if [ $? -ne 0 ]; then
                    583:         echo "Error copying old reboot command!" >&2
                    584:         exit 1
                    585:     fi
                    586:     echo "/sbin/reboot copied to /sbin/oreboot"
1.2       andrew    587: fi
                    588:
1.30      andrew    589: install_kernels
1.21      andrew    590: install_sets
1.2       andrew    591:
1.53      andrew    592: if [ X"$NEW_KERNEL_VERSION" == X"$BOOTED_KERNEL_VERSION" ]; then
1.51      andrew    593:     install_sendmail_smtp_auth
                    594:
1.21      andrew    595:     if [ -e /sbin/oreboot ]; then
                    596:         echo Removing /sbin/oreboot
                    597:         $SUDO rm -f /sbin/oreboot
                    598:     fi
1.2       andrew    599:     update_etc
                    600:
1.54      andrew    601:     echo '==> UPDATING PACKAGES'
1.2       andrew    602:     $SUDO pkg_add -ui -F update -F updatedepends
                    603:
                    604: else
                    605:     echo Instructions for updating to the new version available from
1.36      andrew    606:     if [ X"snapshots" == X"$FORCE_DIR" ]; then
1.30      andrew    607:         echo "  http://www.openbsd.org/faq/current.html"
                    608:     else
                    609:         echo "  http://www.openbsd.org/faq/upgrade${FILE_VER}.html"
                    610:     fi
1.2       andrew    611: fi
                    612:
                    613: echo New kernel installed.  Please reboot!
1.22      andrew    614: if [ -e /sbin/oreboot ]; then
                    615:     echo Possibly using /sbin/oreboot
                    616: fi

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>